/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __COMPARE_RESULT_H__
#define __COMPARE_RESULT_H__

template <class T>
void compare_result(FILE *fpDat, T *x, T *y, const int n)
{
    T diff, dist = 0.0;
	for(int i = 0; i < n; ++i)
	{
		diff = x[i] - y[i];
		dist += diff * diff;
	}
	dist = sqrt(dist / n);
	fprintf(fpDat, "The distance between two solutions is %e\n", dist);
}

#endif /* __COMPARE_RESULT_H__ */
