/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __CONFIG_H__
#define __CONFIG_H__

#define EXECUTE_CPU 0   				/* Execute on CPU */
#define EXECUTE_SINGLE_GPU 1			/* Execute on Single GPU */
#define EXECUTE_MULTI_GPU 0				/* Execute on Multi GPU */
#define COMPARE_RESULT 1
#define PRINT_MATRIX 0
#define PRINT_PRECON 0
#define PRINT_X 0
#define OUTPUT_TECPLOT 0
#define SET_X_INI_ZERO 1
#define SET_SUPER_MAX_ITER 1
#define USE_ERROR_REL 1
#define USE_SAME_ERROR 0
#define USE_FLOAT_PRECON 0
#define USE_CPU_PRECON 0

#define TYPE double
#define USE_PAGE_LOCKED 0
#define USE_ALIGNED_OPT_SPM 1
#define USE_ALIGNED_OPT_PRECON 0
#define USE_TEXTURE 0
#define USE_DYNAMIC_INTERVAL_SIZE 0

#define GPU_PER_THREAD 1
#define MAX_GPU_COUNT 6
#define INTERVAL_SIZE 16
#define MAX_INTERVAL_SIZE 32
#define SHOW_INTERVAL 1
#define GMRES_RESTART 64
#define MAX_ITER 50000
#define SUPER_MAX_ITER 10000000
#define ERROR_REL 1e-6
#define ERROR_ABS 1e-14
#define OMEGA 0.5

#define DIMBLOCK 256
#define HALFWARP 16

template<typename Arg, typename Result>
struct convert: std::unary_function<Arg, Result> 
{
    Result operator() (const Arg x) 
    {
        return  static_cast<Result>(x);
    }   
}; 

#endif /* __CONFIG_H__ */
