/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __CUTILS_H__
#define __CUTILS_H__

inline void cublasXaxpy(const int n, const float alpha, float *x, const int inc_x, float *y, const int inc_y)
{
    cublasSaxpy(n, alpha, x, inc_x, y, inc_y);
}

// cublasDaxpy
inline void cublasXaxpy(const int n, const double alpha, double *x, const int inc_x, double *y, const int inc_y)
{
    cublasDaxpy(n, alpha, x, inc_x, y, inc_y);
}

// cublasScal
inline void cublasXscal(const int n, const float alpha, float *x, const int inc_x)
{
    cublasSscal(n, alpha, x, inc_x);
}

// cublasDscal
inline void cublasXscal(const int n, const double alpha, double *x, const int inc_x)
{
    cublasDscal(n, alpha, x, inc_x);
}

// cublasSdot
inline float cublasXdot(const int n, float *x, const int inc_x, float *y, const int inc_y)
{
    return  cublasSdot(n, x, inc_x, y, inc_y);
}

// cublasDdot
inline double cublasXdot(const int n, double *x, const int inc_x, double *y, const int inc_y)
{
    return  cublasDdot(n, x, inc_x, y, inc_y);
}

// cublasScopy
inline void cublasXcopy(const int n, float *x, const int inc_x, float *y, const int inc_y)
{
    cublasScopy(n, x, inc_x, y, inc_y);
}

// cublasDcopy
inline void cublasXcopy(const int n, double *x, const int inc_x, double *y, const int inc_y)
{
    cublasDcopy(n, x, inc_x, y, inc_y);
}

// cublasSnrm2
inline float cublasXnrm2(const int n, float *x, const int incx)
{
    return  cublasSnrm2(n, x, incx);
}

// cublasDnrm2
inline double cublasXnrm2(const int n, double *x, const int incx)
{
    return  cublasDnrm2(n, x, incx);
}

#endif /* __CUTILS_H__ */
