/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __INCLUDE_H__
#define __INCLUDE_H__

/* must in order */
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <functional>
#include <algorithm>
#include <math.h>
#include <cublas.h>
#include <cutil_inline.h>
#include <cuda_runtime_api.h>

#include "config.h"
#include "timer.h"
#include "iofile.h"
#include "spmatrix.h"
#include "spm_diag.h"
#include "spm_triangle.h"
#include "texture.h"
#include "gpu_kernels.cu"
#include "csr_format.h"
#include "ell_format.h"
#include "Jacobi_precon.h"
#include "ssor_precon.h"
#include "sub_ssor_precon.h"
#include "cg_host.h"
#include "cg_device.h"
#include "cg_multi_device.h"
#include "pcg_host.h"
#include "pcg_device.h"
#include "pcg_multi_device.h"
#include "pgmres_host.h"
#include "pgmres_device.h"
#include "compare_result.h"
#include "output_tecplot.h"

#endif /* __INCLUDE_H__ */
