/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __IOFILE_H__
#define __IOFILE_H__

void read_data(double *a, char *filename, const int num)
{
    FILE *f;
    f = fopen(filename, "r");
    if (!f) 
    {
        printf("Can not open file: %s\n", filename);
        exit(EXIT_FAILURE);
    }
    int i = 0;
    char line[256];
    while(((fgets(line, 256, f)) != NULL) && (i < num)) 
    {
        sscanf(line, "%lg", &(a[i]));
		//printf("%lg\n", a[i]);
        i++;
    }
    if(i < num) exit(EXIT_FAILURE);
    fclose(f);	
}

template <class T>
void write_x(T *x, char *x_filename, const int ncol)
{
    FILE *f;
    f = fopen(x_filename, "w");
    if (!f) {
        printf("Can not open file: %s\n", x_filename);
        exit(EXIT_FAILURE);
    }
    for (int i = 0; i < ncol; i++)
    fprintf(f, "%f\n", x[i]);
    fclose(f);
}

#endif /* __IOFILE_H__ */
