/*
 * CUDA for Sparse Solver
 * Author: Luo Li     li.luo@sub.siat.ac.cn
 */ 

#ifndef __OUTPUT_TECPLOT_H__
#define __OUTPUT_TECPLOT_H__

template <class T>
void output_tecplot(T *x, const int x_num, const int y_num, const T hx, const T hy)
{
    int i, j;
    FILE *fpOut;
    if ((fpOut=fopen("output.plt", "w")) == NULL )
    {
        printf("can't open file 'output.plt'\n");
        exit(EXIT_FAILURE);
    }
    fprintf(fpOut, "TITLE     = \"conjugateGradient\"\n");
    fprintf(fpOut, "VARIABLES = \"X\"\n\"Y\"\n\"T\"\n");
    fprintf(fpOut, "ZONE T=\"TTT\"\nI=%d, J=%d, ZONETYPE=Ordered\n", y_num, x_num);
    fprintf(fpOut, "DATAPACKING=POINT\n");
    for (i = 0; i < x_num; i++)
        for (j = 0; j < y_num; j++)
            fprintf(fpOut, "%f \t%f \t%f\n", -100.0 + (i + 0.5) * hx, -100.0 + (j + 0.5) * hy, (TYPE)(x[j * x_num + i]));
    fclose(fpOut);	
}

#endif /* __OUTPUT_TECPLOT_H__ */
